package pa_model;


import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.swing.JOptionPane;

import bsh.This;
import repast.simphony.context.Context;
import repast.simphony.engine.environment.RunState;
import repast.simphony.engine.schedule.ScheduleParameters;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.random.RandomHelper;

public class Agent {


	
	private int inModelID;
	//////////FROM data set read in files at initialisation////////////////
	private int id, had_CVD, had_T2D, smoking, familyCVDHistory, bpTreatment, rheumatoidArthritis, chronicKidneyDisease, atrialFibrillation, had_T1D, cort, familyT2DHistory, education, 
	had_depression, had_MSI, longLastingIllness, comorbidity;
	private double paStatus, age, bmi, hdlRatio, sBloodPressure, dBloodPressure, deprivationTown, sampleWeight, utilityImpeq5d, deprivationIMD, socioEconomicClass; 
		
	private String gender, ethnicity;
	
	////////////////////////////END///////////////
	
	//////////////////////////////////
	
	/////////////VARIABLES for individual output/////////////////
	private double ageAtEntry, ageAtSimEnd, ageAtDeath, lifeYears, paStatusAtEntry, paStatusAtSimEnd, paStatusAtDeath, 
	bmiAtEntry, bmiAtEnd, hdlRatioAtEntry, hdlRatioAtEnd, sbpAtEntry, sbpAtEnd, utilityAtEntry, utilityAtEnd;
	
	/////////////VARIABLES for updates/////////////////
	private int totalNoOfEvents, totalNoOfCVD, noOfMSI, noOfDprsEpisodes, noOfStroke, noOfCHD, noOfT2D, noOfInterventionsIntro, noOfInterventionsUptake; 
	private double currentUtility, baselineUtility, paPreviousPeriod, dprsProbability, msiProbability;
	private double totalCost, totalCostDiscounted, totalEventCost, totalEventCostDiscounted, totalInterventionCost, totalInterventionCostDiscounted, 
	totalQALYS, totalQALYsDiscounted, totalInterventionCost_health, totalInterventionCost_healthDiscounted, totalInterventionCost_sport, 
	totalInterventionCost_sportDiscounted, totalInterventionCost_education, totalInterventionCost_educationDiscounted, 
	totalInterventionCost_transport, totalInterventionCost_transportDiscounted, totalInterventionCost_localAuthorities, totalInterventionCost_localAuthoritiesDiscounted, totalInterventionCost_other, totalInterventionCost_otherDiscounted; 
	private String causeOfDeath;
	
	private double yearsActive;
	
	public static int repReadData; // = repCounter -1; this is for the array map of events, interventions, probabilities, etc. data  
	
	//keep variables for update events and interventions * use in record id for index for the corresponding event or intervention
	private double qRisk, dRisk, paAdjustedDiabetesRisk, paAdjustedStrokeRisk, paAdjustedCHDRisk, paAdjustedDprsProbability, paAdjustedMSIProbability;
	
	//private List eventHistory, interventionIntroducedHistory, interventionUptakeHistory;
	//private List interventionIntroducedHistory, interventionUptakeHistory;
	
	private ArrayList<IntroducedIntervention> interventionsIntroducedList = new ArrayList<IntroducedIntervention>();
	private ArrayList<UptakeIntervention> interventionsUptakeList = new ArrayList<UptakeIntervention>();
	private ArrayList<OccuredEvent> chdEventsList = new ArrayList<OccuredEvent>();
	private ArrayList<OccuredEvent> strokeEventsList = new ArrayList<OccuredEvent>();
	private ArrayList<OccuredEvent> t2dEventsList = new ArrayList<OccuredEvent>();
	private ArrayList<OccuredEvent> msiEventsList = new ArrayList<OccuredEvent>();
	private ArrayList<OccuredEvent> depressionEventsList = new ArrayList<OccuredEvent>();
	
	// eventHistory, interventionIntroducedHistory, interventionUptakeHistory keep time and name of element e.g. total events = eventHistory.size()
	/////////////////////END/////////////////////
	private String nameOfInterventionsIntro = "";
	private String nameOfInterventionsUptake = "";
	
	private boolean isDead, checkPAonUtilityEffect, inAcutePeriod;
	
	Context context = RunState.getInstance().getMasterContext();
	
	
	
	public Agent(int inModelID){
		
		//this.eventHistory = new ArrayList();
		//this.interventionIntroducedHistory = new ArrayList();
		//this.interventionUptakeHistory = new ArrayList();
		
		this.inModelID = inModelID;
		this.isDead = false;
		this.checkPAonUtilityEffect = true;
		this.inAcutePeriod = false;
		
		this.yearsActive = 0.0;
		this.totalCost = 0.0;
		this.totalCostDiscounted = 0.0;
		this.totalEventCost = 0.0;
		this.totalEventCostDiscounted = 0.0;
		this.totalInterventionCost = 0.0;
		this.totalInterventionCostDiscounted = 0.0;
		this.totalQALYS = 0.0;
		this.totalQALYsDiscounted = 0.0;
		this.totalInterventionCost_health = 0.0;
		this.totalInterventionCost_healthDiscounted = 0.0;
		this.totalInterventionCost_sport = 0.0;
		this.totalInterventionCost_sportDiscounted = 0.0; 
		this.totalInterventionCost_education = 0.0;
		this.totalInterventionCost_educationDiscounted = 0.0; 
		this.totalInterventionCost_transport = 0.0;
		this.totalInterventionCost_transportDiscounted = 0.0; 
		this.totalInterventionCost_localAuthorities =0.0;
		this.totalInterventionCost_localAuthoritiesDiscounted = 0.0;
		this.totalInterventionCost_other = 0.0;
		this.totalInterventionCost_otherDiscounted = 0.0;
			
		this.totalNoOfEvents = 0;
		this.totalNoOfCVD = 0;
		this.noOfMSI = 0;
		this.noOfDprsEpisodes = 0;
		this.noOfStroke = 0;
		this.noOfCHD = 0;
		this.noOfT2D = 0;
		this.noOfInterventionsIntro = 0;
		this.noOfInterventionsUptake = 0;
	}
	
		@ScheduledMethod(start=1, interval=1, priority=5, shuffle=false)
		public void step(){
			
			if(!(PAContext.clock.getClockYears()==0.0)){
				//all living agents follow the process below 
				
				if(!this.isDead){
					
					if(this.age<25){
						this.qRisk = 0.0;
						this.dRisk = 0.0;
					}
					else{
						this.calculateTimeAdjustedRisk();
					}
					
					if(this.age<5){
						this.setDprsProbability(0);
					}
					else{
						this.updateDprsProbability();
					}
					
					this.updateMSIProbability();
			
					this.paAdjustedDiabetesRisk = Util.rrPAEventRisk(this, PAContext.rrPAOnDiabetes)*this.dRisk;
					this.paAdjustedDprsProbability = Util.rrPADprsProbability(this)*this.dprsProbability;
					this.paAdjustedMSIProbability = Util.rrPAmsiProbability(this)*this.msiProbability;
					this.paAdjustedStrokeRisk = this.qRisk*Util.cvdStrokeProportion(this)*Util.rrPAEventRisk(this, PAContext.rrPAOnStroke);
					this.paAdjustedCHDRisk = this.qRisk*Util.cvdCHDProportion(this)*Util.rrPAEventRisk(this, PAContext.rrPAOnCHD);
					
					this.eventCheck();
					
					/*
					 * some events have fatality risk. if agents have not died from an event we check intervention suitability 
					 * and advance age & age related characteristics
					*/
					if(!this.isDead){
						this.interventionCheck();
						/*
						System.out.println("this.paPreviousPeriod");
						System.out.println(this.paPreviousPeriod);
						System.out.println("this.paStatus");
						System.out.println(this.paStatus);
						*/
						this.paPreviousPeriod = this.paStatus;
						
						//System.out.println(inAcutePeriod);
						
						if(!inAcutePeriod){
							
						/*
							System.out.println("NOT IN ACUTE");
							System.out.println("this.paPreviousPeriod");
							System.out.println(this.paPreviousPeriod);
							System.out.println("this.paStatus");
							System.out.println(this.paStatus);
							System.out.println("#### NOT IN ACUTE ####");
							*/
							Util.updateBaselinePAStatus(this);	
							
						}
						
						Util.updateBaselineUtility(this);
						
						//one-off change of PA effect on utility
						if(this.checkPAonUtilityEffect){
							double sexCoef;
							double dPA = this.paStatus - this.paPreviousPeriod;
							if(this.getGender().equalsIgnoreCase("M")){sexCoef = 0.0000244;}
							else{sexCoef = 0.0000306;}
							
							if(dPA != 0){
								this.setBaselineUtility(this.getBaselineUtility()+sexCoef*dPA);
								this.setCurrentUtility(this.getBaselineUtility());
								this.checkPAonUtilityEffect = false;
							}
						}
						
						Util.interventionUpdates(this); // cost and PA status
						
					
						
						this.updateAge();
						this.checkDeath();
					}
					
					Util.eventUpdates(this); // cost and utility (current utility that is used for QALYs update)
		
				
					this.updateTotalCost();
					this.updateQALYS();
				/*
					IndividualTrackingOutput ind = new IndividualTrackingOutput(this);
					ind.writeOutIndividualTrack(this);
				//*/
				}
			}
			
		}
		
			
		public void calculateTimeAdjustedRisk(){
		
			this.qRisk = Util.calculateTimeAdjustedProbability(this, Util.calculateQRisk(this, repReadData), 10, Util.CONVERT_YEARS);
			if(!this.hasT2D() && !this.hadT1D()){
				this.dRisk = Util.calculateTimeAdjustedProbability(this, Util.calculateDRisk(this, repReadData), 10, Util.CONVERT_YEARS);
			}
		}
		
		public void updateDprsProbability(){
			if (this.getAge()>=5 && this.getAge()<=15){this.setDprsProbability(PAContext.probDepression.get(1).get(repReadData));}
			else if (this.getAge()>=16 && this.getAge()<=24){this.setDprsProbability(PAContext.probDepression.get(2).get(repReadData));}
			else if (this.getAge()>=25 && this.getAge()<=44){this.setDprsProbability(PAContext.probDepression.get(3).get(repReadData));}
			else if (this.getAge()>=45 && this.getAge()<=64){this.setDprsProbability(PAContext.probDepression.get(4).get(repReadData));}
			else if (this.getAge()>=65 && this.getAge()<=74){this.setDprsProbability(PAContext.probDepression.get(5).get(repReadData));}
			else if (this.getAge()>=75){this.setDprsProbability(PAContext.probDepression.get(6).get(repReadData));}
			
		}
		
		public void updateMSIProbability(){
			if (this.getAge()<18){this.setMSIProbability(PAContext.probMSI.get(0).get(repReadData));}
			else if (this.getAge()>=18 && this.getAge()<=44){this.setMSIProbability(PAContext.probMSI.get(1).get(repReadData));}
			else if (this.getAge()>=45 && this.getAge()<=64){this.setMSIProbability(PAContext.probMSI.get(2).get(repReadData));}
			else if (this.getAge()>=65 && this.getAge()<=74){this.setMSIProbability(PAContext.probMSI.get(3).get(repReadData));}
			else if (this.getAge()>=75){this.setMSIProbability(PAContext.probMSI.get(4).get(repReadData));}
			
		}
		
		public void eventCheck(){

			double temp = 0;
			double tempQ = PAContext.myGenerator.nextDouble();
			//double tempCVD = PAContext.myGenerator.nextDouble();
			for (Iterator i = PAContext.replicationsData.getDataList().iterator();i.hasNext();){ 
				Record rec = (Record) i.next();
				if(rec.getType().equalsIgnoreCase(DataType.EVENT.toString().trim())){
					if(!this.isDead && rec.getName().equalsIgnoreCase(Events.DEPRESSION.toString().trim())){
						temp = PAContext.myGenerator.nextDouble();
				
						if (temp < this.paAdjustedDprsProbability) {
							//get depression
							
							Util.getEvent(depressionEventsList, rec, this);
					
						    //fatality? 	
							
						}
						
					}
					
					if(!this.isDead && rec.getName().equalsIgnoreCase(Events.MSI.toString().trim())){
						temp = PAContext.myGenerator.nextDouble(); 
						
						if (temp < this.paAdjustedMSIProbability){
							rec.getInModelID();
							//get msi
					
							Util.getEvent(msiEventsList, rec, this);
							
							//do not check fatality
						}
						
					}
					
					if(!this.isDead && rec.getName().equalsIgnoreCase(Events.T2D.toString().trim())){
						if(!this.hasT2D() && !this.hadT1D()){
							temp = PAContext.myGenerator.nextDouble();
						
							if(temp<this.paAdjustedDiabetesRisk){
								rec.getInModelID();
								//get T2D
								
								Util.getEvent(t2dEventsList, rec, this); 
								
								//do not check fatality
							}
						}
					}
					
					if (!this.isDead && (rec.getName().equalsIgnoreCase(Events.STROKE.toString().trim())) || (rec.getName().equalsIgnoreCase(Events.CHD.toString().trim()))){
								
						if(tempQ<=this.paAdjustedStrokeRisk){
							
							if ((!this.isDead) && (rec.getName().equalsIgnoreCase(Events.STROKE.toString().trim()))){
								rec.getInModelID();
								//get stroke
								
								Util.getEvent(strokeEventsList, rec, this);
								
								double temp1 = PAContext.myGenerator.nextDouble();
								if (temp1 < Util.fatalityStroke(this)){
									this.setPAStatus(rec.getEventAcutePA(repReadData));
									this.die("Death from stroke");
								}
							}
						}
						else if (tempQ>this.paAdjustedStrokeRisk && tempQ<=(this.paAdjustedStrokeRisk+this.paAdjustedCHDRisk)){
							if ((!this.isDead) && (rec.getName().equalsIgnoreCase(Events.CHD.toString().trim()))){
								rec.getInModelID();
								//get CHD
								
								Util.getEvent(chdEventsList, rec, this);
								
								double temp1 = PAContext.myGenerator.nextDouble();
								if (temp1 < Util.fatalityCHD(this)){
									this.setPAStatus(rec.getEventAcutePA(repReadData));
									this.die("Death from CHD");
								}
							}
						}						
					}
					
				}
			}
			
		}
		
		
		
		public void updateAge(){
			this.age += Util.CONVERT_YEARS;
			Util.updateAgeRelatedCharacteristics(this);
			this.lifeYears += Util.CONVERT_YEARS;
			this.updateYearsActive();
		} 
				
				
		public void updateYearsActive(){
			if (this.paStatus>=Util.PA_ACTIVE_THRESHOLD){
				this.yearsActive+=Util.CONVERT_YEARS;
			}
		}
		
		public void checkDeath(){
			double temp = PAContext.myGenerator.nextDouble();
			int ageRoundDown = (int) Math.floor(this.getAge());
			double rr = 0;
		
			if(ageRoundDown>100){this.die("Death over 100");}
			else if(ageRoundDown<=100){
				
					if(this.hasCHD()){ // CHD mortality
						
						if(this.getGender().equals("M")){
							rr = PAContext.mortality3monthsMaleHealthyNonCVD[ageRoundDown]*PAContext.rrMortality.get(0).get(repReadData);
							if(temp<rr){this.die("CHD death from other causes");} // CHD death from other causes
						}
						else{
							rr = PAContext.mortality3monthsFemaleHealthyNonCVD[ageRoundDown]*PAContext.rrMortality.get(0).get(repReadData);
							if(temp<rr){this.die("CHD death from other causes");} //CHD death from other causes
						}
					}
					else if(this.hadT1D() || this.hasT2D()){ // Diabetes mortality
						
						if(this.getGender().equals("M")){
							rr = PAContext.mortality3monthsMaleHealthyNonCVD[ageRoundDown]*PAContext.rrMortality.get(1).get(repReadData);
							if(temp<rr){this.die("Diabetes death from other causes");} // Diabetes death from other causes
						}
						else{
							rr = PAContext.mortality3monthsFemaleHealthyNonCVD[ageRoundDown]*PAContext.rrMortality.get(1).get(repReadData);
							if(temp<rr){this.die("Diabetes death from other causes");} //Diabetes death from other causes
						}
					}
					else if(this.hasDepression()){ // Depression mortality
						if(this.getGender().equals("M")){
							rr = PAContext.mortality3monthsMaleHealthyNonCVD[ageRoundDown]*PAContext.rrMortality.get(2).get(repReadData);
							if(temp<rr){this.die("Depression death from other causes");} //Depression death from other causes
						}
						else{
							rr = PAContext.mortality3monthsFemaleHealthyNonCVD[ageRoundDown]*PAContext.rrMortality.get(2).get(repReadData);
							if(temp<rr){this.die("Depression death from other causes");} //Depression death from other causes
						}
					}
					else if(this.hasMSI()){ // MSI mortality
						if(this.getGender().equals("M")){
							rr = PAContext.mortality3monthsMaleHealthyNonCVD[ageRoundDown]*PAContext.rrMortality.get(3).get(repReadData);
							if(temp<rr){this.die("MSI death from other causes");} // MSI death from other causes							
						}
						else{
							rr = PAContext.mortality3monthsFemaleHealthyNonCVD[ageRoundDown]*PAContext.rrMortality.get(3).get(repReadData);
							if(temp<rr){this.die("MSI death from other causes");} //MSI death from other causes
						}
					}
					else{ // Healthy mortality
						if(this.getGender().equals("M")){
							rr = PAContext.mortality3monthsMaleHealthyNonCVD[ageRoundDown];
							if(temp<rr){this.die("Death from other causes");}
						}
						else{
							rr = PAContext.mortality3monthsFemaleHealthyNonCVD[ageRoundDown];
							if(temp<rr){this.die("Death from other causes");}
						}
					}
				
			}
	
			
		}
		
		public void interventionCheck(){
			double temp = 0;
			
			for (Iterator i = PAContext.replicationsData.getDataList().iterator();i.hasNext();){ 
				Record rec = (Record) i.next();
				
				boolean checkIntro = true;
				if(rec.getType().equalsIgnoreCase(DataType.INTERVENTION.toString())){
			
					for(int j=0; j<this.interventionsIntroducedList.size(); j++){
			
						if(this.interventionsIntroducedList.get(j).getInterventionName().equalsIgnoreCase(rec.getInterventionName(repReadData))){
							checkIntro = false;
						}
					}
			
					if(checkIntro){
			
						//TODO how to check disease???
						double inAgeMin = rec.getInterventionIntroAgeMin(repReadData);
						double inAgeMax = rec.getInterventionIntroAgeMax(repReadData);
						double inPAMin = rec.getInterventionIntroPAStatusMin(repReadData);
						double inPAMax = rec.getInterventionIntroPAStatusMax(repReadData);
						String sex = rec.getInterventionIntroGender(repReadData);
						if(this.age >= inAgeMin && this.age <= inAgeMax && this.paStatus >= inPAMin && this.paStatus <= inPAMax){
							if(!(sex.equalsIgnoreCase("ALL")) && !(this.getGender().equalsIgnoreCase(sex))){}
							else {
								Util.introduceIntervention(interventionsIntroducedList, rec, this);
								temp = PAContext.myGenerator.nextDouble();
								if(temp<rec.getInterventionUptakeProbability(repReadData)){
									Util.uptakeIntervention(interventionsUptakeList, rec, this);
								}
							}
						}
					}
				}
			}
		}
				
		public void updateTotalCost(){
			this.totalCost = this.getTotalEventCost()+this.getTotalInterventionCost();
		}
		
		public void updateTotalCostDiscounted(){
			this.totalCostDiscounted = this.getTotalEventCostDiscounted()+this.getTotalInterventionCostDiscounted();
		}
		
		public void updateTotalEventCost(double eventCost){
			this.totalEventCost += eventCost;
		}
		//TODO public void updateTotalEventCostDiscounted(){}
		public void updateTotalInterventionCost(double interventionCost){
			this.totalInterventionCost = interventionCost;
		}
		//TODO public void updateTotalInterventionCostDiscounted(){}
				
		public void updateQALYS(){
			double QALYsSimTimeUnit;
			QALYsSimTimeUnit = Util.CONVERT_YEARS*this.currentUtility;
			this.totalQALYS+=QALYsSimTimeUnit;	
		}
		
		public void die(String causeOfDeath){
			this.isDead = true;
			this.ageAtDeath = this.age;
			this.paStatusAtDeath = this.getPAStatus();
			this.causeOfDeath = causeOfDeath;
			
			PAContext.deadCounter++;
		
			if (PAContext.deadCounter>=PAContext.cohortSize){
				PAContext pa = new PAContext();
				PAContext.schedule.schedule(ScheduleParameters.createOneTime(Util.getCurrentTime(), ScheduleParameters.LAST_PRIORITY), pa, "end");
			}	
		}
	
	
		//////START seed data
		public int getID(){
			return this.id;
		}
		
		public void setID(int id){
			this.id = id;
		}
		
		public void setInModelID(int inModelID){
			this.inModelID = inModelID;
		}
		
		public int getInModelID(){
			return this.inModelID;
		}
		
		public double getPAStatus() {
			return this.paStatus;
		}
		
		public void setPAStatus(double paStatus){
			this.paStatus = paStatus;
		}
		
		public double getAge(){
			return this.age;
		}
		
		public void setAge(double age){
			this.age = age; 
		}
		
		public String getGender(){
			return this.gender;
		}
		
		public void setGender(String gender){
			this.gender = gender;
		}
		
		//history CVD from health survey for England
		public int getHadCVD(){
			return this.had_CVD;
		}
		
		public void setHadCVD(int had_CVD){
			this.had_CVD = had_CVD;
		}
		
		//event during simulation
		public boolean hasCHD(){
			if(this.noOfCHD != 0){return true;}
			else{return false;}
		}
		
		public boolean hasStroke(){
			if(this.noOfStroke != 0){return true;}
			else{return false;}
		}
		
		// both history and simulation 
		public boolean hasCVD(){
			if (this.getHadCVD() == 1 || this.hasCHD() || this.hasStroke()) {return true;}
			else {return false;}
		}
		
		public int getHadT2D(){
			return this.had_T2D;
		}
		
		public void setHadT2D(int had_T2D){
			this.had_T2D = had_T2D;
		}
		
		public boolean hasT2D(){
			if(this.getHadT2D()==1 || this.noOfT2D != 0){return true;}
			else {return false;}
		}
		
		public int getHadDepression(){
			return this.had_depression;
		}
		
		public void setHadDepression(int had_depression){
			this.had_depression = had_depression;
		}
		
		public boolean hasDepression(){
			if(this.getHadDepression()==1 && this.noOfDprsEpisodes != 0){return true;}
			else {return false;}
		}
		
		public int getHadMSI(){
			return this.had_MSI;
		}
		
		public void setHadMSI(int had_MSI){
			this.had_MSI = had_MSI;
		}
		
		public boolean hasMSI(){
			if(this.getHadMSI()==1 && this.noOfMSI != 0){return true;}
			else {return false;}
		}
		
		public double getBMI(){
			return this.bmi;
		}
		
		public void setBMI(double bmi){
			this.bmi = bmi;
		}
		
		public double getHDLRatio(){
			return this.hdlRatio;
		}
		
		public void setHDLRatio(double hdlRatio){
			this.hdlRatio = hdlRatio;
		}
		
		public double getSBloodPressure(){
			return this.sBloodPressure;
		}
		
		public void setSBloodPressure(double sBloodPressure){
			this.sBloodPressure = sBloodPressure;
		}
		
		public double getDBloodPressure(){
			return this.dBloodPressure;
		}
		
		public void setDBloodPressure(double dBloodPressure){
			this.dBloodPressure = dBloodPressure;
		}		
		
		public int getSmoking(){
			return this.smoking;
		}
		
		public void setSmoking(int smoking){
			this.smoking = smoking;
		}
		
		public boolean isSmoker(){
			if(this.getSmoking()==0 || this.getSmoking()==1){return false;}
			else{return true;}
		}
		
		public String getEthnicity(){
			return this.ethnicity;
		}
		
		public void setEthnicity(String ethnicity){
			this.ethnicity = ethnicity;
		}
		
		public int getFamilyCVDHistory(){
			return this.familyCVDHistory;
		}
		
		public void setFamilyCVDHistory(int familyCVDHistory){
			this.familyCVDHistory = familyCVDHistory;
		}
		
		public boolean hasCVDFamilyHistory(){
			if(this.getFamilyCVDHistory()==1){return true;}
			else{return false;}
		}
		
		public int getEducation(){
			return this.education;
		}
		
		public void setEducation(int education){
			this.education = education;
		}
		
		public double getSampleWeight(){
			return this.sampleWeight;
		}
		
		public void setSampleWeight(double sampleWeight){
			this.sampleWeight = sampleWeight;
		}
		
		public double getDeprivationTown(){
			return this.deprivationTown;
		}
		
		public void setDeprivationTown(double deprivationTown){
			this.deprivationTown = deprivationTown;
		}

		public int getBpTreatment(){
			return this.bpTreatment;
		}
		
		public void setBpTreatment(int bpTreatment){
			this.bpTreatment = bpTreatment;
		}
		
		public boolean onBpTreatment(){
			if(this.getBpTreatment()==1){return true;}
			else{return false;}
		}
		
		public int getRheumatoidArthritis(){
			return this.rheumatoidArthritis;
		}
		
		public void setRheumatoidArthritis(int rheumatoidArthritis){
			this.rheumatoidArthritis = rheumatoidArthritis;
		}
		
		public boolean hasRheumatoidArthritis(){
			if(this.getRheumatoidArthritis()==1){return true;}
			else{return false;}
		}
		
		public int getChronicKidneyDisease(){
			return this.chronicKidneyDisease;
		}
		
		public void setCHronicKidneyDisease(int chronicKidneyDisease){
			this.chronicKidneyDisease = chronicKidneyDisease;
		}
		
		public boolean hasChronicKidneyDisease(){
			if(this.getChronicKidneyDisease()==1){return true;}
			else{return false;}
		}
		
		public int getAtrialFibrillation(){
			return this.atrialFibrillation;
		}
		
		public void setAtrialFibrillation(int atrialFibrillation){
			this.atrialFibrillation = atrialFibrillation;
		}
		
		public boolean hasAtrialFibrillation(){
			if(this.getAtrialFibrillation()==1){return true;}
			else{return false;}
		}
		
		public int getHadT1D(){
			return this.had_T1D;
		}
		
		public void setHadT1D(int had_T1D){
			this.had_T1D = had_T1D;
		}
		
		public boolean hadT1D(){
			if(this.getHadT1D()==1){return true;}
			else{return false;}
		}
		
		public int getCort(){
			return this.cort;
		}
		
		public void setCort(int cort){
			this.cort = cort;
		}
		
		public int getFamilyT2DHistory(){
			return this.familyT2DHistory;
		}
		
		public void setFamilyT2DHistory(int familyT2DHistory){
			this.familyT2DHistory = familyT2DHistory;
		}
		
		public boolean hasT2DFamilyHistory(){
			if(this.getFamilyT2DHistory()==1){return true;}
			else{return false;}
		}
		
		public double getUtilityIMPEQ5D(){
			return this.utilityImpeq5d;
		}
		
		public void setUtilityIMPEQ5D(double utilityImpeq5d){
			this.utilityImpeq5d = utilityImpeq5d;
		}
		
		public double getDeprivationIMD(){
			return this.deprivationIMD;
		}
		
		public void setDeprivationIMD(double deprivationIMD){
			this.deprivationIMD = deprivationIMD;
		}
		
		public double getSocioEconomicClass(){
			return this.socioEconomicClass;
		}
		
		public void setSocioEconomicClass(double sec){
			this.socioEconomicClass = sec;
		}
		
		public int getLongLastingIllness(){
			return this.longLastingIllness;
		}
		
		public void setLongLastingIllness(int lli){
			this.longLastingIllness = lli;
		}
		
		public int getComorbidity(){
			return this.comorbidity;
		}
		
		public void setComorbidity(int comorbidity){
			this.comorbidity = comorbidity;
		}
		
		
		//////END seed data
		
		public boolean getInAcutePeriod(){
			return this.inAcutePeriod;
		}
		
		public void setInAcutePeriod(boolean inAcutePeriod){
			this.inAcutePeriod = inAcutePeriod;
		}
		
		
		public boolean getCheckPAonUtilityEffect(){
			return this.checkPAonUtilityEffect;
		}
		
		public void setCheckPAonUtilityEffect(boolean checkPAonUtilityEffect){
			this.checkPAonUtilityEffect = checkPAonUtilityEffect;
		}
		
		public boolean getIsDead(){
			return this.isDead;
		}
		
		public void setIsDead(boolean isDead){
			this.isDead = isDead;
		}
		
		public double getAgeAtEntry(){
			return this.ageAtEntry;
		}
		public void setAgeAtEntry(double ageAtEntry){
			this.ageAtEntry = ageAtEntry;
		}
		
		public double getAgeAtSimEnd(){
			return this.ageAtSimEnd;
		}
		public void setAgeAtSimEnd(double ageAtSimEnd){
			this.ageAtSimEnd = ageAtSimEnd;
		}
		
		public double getAgeAtDeath(){
			return this.ageAtDeath;
		}
		public void setAgeAtDeath(double ageAtDeath){
			this.ageAtDeath = ageAtDeath;
		}
		
		public double getLifeYears(){
			return this.lifeYears;
		}
		public void setLifeYears(double lifeYears){
			this.lifeYears = lifeYears;
		}
		
		public double getPAStatusAtEntry(){
			return this.paStatusAtEntry;
		}
		public void setPAStatusAtEntry(double paStatusAtEntry){
			this.paStatusAtEntry = paStatusAtEntry;
		}
		
		public double getPAStatusAtSimEnd(){
			return this.paStatusAtSimEnd;
		}
		public void setPAStatusAtSimEnd(double paStatusAtSimEnd){
			this.paStatusAtSimEnd = paStatusAtSimEnd;
		}
		
		public double getPAStatusAtDeath(){
			return this.paStatusAtDeath;
		}
		public void setPAStatusAtDeath(double paStatusAtDeath){
			this.paStatusAtDeath = paStatusAtDeath;
		}
		
		public double getBMIAtEntry(){
			return this.bmiAtEntry;
		}
		
		public void setBMIAtEntry(double bmiAtEntry){
			this.bmiAtEntry = bmiAtEntry;
		}
		public double getBMIAtEnd(){
			return this.bmiAtEnd;
		}
		
		public void setBMIAtEnd(double bmiAtEnd){
			this.bmiAtEnd = bmiAtEnd;
		}
		public double getHDLRatioAtEntry(){
			return this.hdlRatioAtEntry;
		}
		
		public void setHDLRatioAtEntry(double hdlRatioAtEntry){
			this.hdlRatioAtEntry = hdlRatioAtEntry;
		}
		public double getHDLRatioAtEnd(){
			return this.hdlRatioAtEnd;
		}
		
		public void setHDLRatioAtEnd(double hdlRatioAtEnd){
			this.hdlRatioAtEnd = hdlRatioAtEnd;
		}
		public double getSBPAtEntry(){
			return this.sbpAtEntry;
		}
		
		public void setSBPAtEntry(double sbpAtEntry){
			this.sbpAtEntry = sbpAtEntry;
		}
		public double getSBPAtEnd(){
			return this.sbpAtEnd;
		}
		
		public void setSBPAtEnd(double sbpAtEnd){
			this.sbpAtEnd = sbpAtEnd;
		}
		
		public double getUtiiltyAtEntry(){
			return this.utilityAtEntry;
		}
		
		public void setUtilityAtEntry(double utilityAtEntry){
			this.utilityAtEntry = utilityAtEntry;
		}
		public double getUtiiltyAtEnd(){
			return this.utilityAtEnd;
		}
		
		public void setUtilityAtEnd(double utilityAtEnd){
			this.utilityAtEnd = utilityAtEnd;
		}
		
		public double getYearsActive(){
			return this.yearsActive;
		}
		public void setYearsActive(double yearsActive){
			this.yearsActive = yearsActive;
		}
		
		public int getTotalNoOfEvents(){
			return this.totalNoOfEvents;
		}
		
		public void setTotalNoOfEvents(int totalNoOfEvents){
			this.totalNoOfEvents = totalNoOfEvents;
		}
		
		public int getTotalNoOfCVD(){
			return this.totalNoOfCVD;
		}
		
		public void setTotalNoOfCVD(int totalNoOfCVD){
			this.totalNoOfCVD = totalNoOfCVD;
		}
		
		public int getNoOfMSI(){
			return this.noOfMSI;
		}
		
		public void setNoOfMSI(int noOfMSI){
			this.noOfMSI = noOfMSI;
		}
		
		public int getNoOfDprsEpisodes(){
			return this.noOfDprsEpisodes;
		}
		
		public void setNoOfDprsEpisodes(int noOfDprsEpisodes){
			this.noOfDprsEpisodes = noOfDprsEpisodes;
		}
			
		public int getNoOfStroke(){
			return this.noOfStroke;
		}
		
		public void setNoOfStroke(int noOfStroke){
			this.noOfStroke = noOfStroke;
		}
		
		public int getNoOfCHD(){
			return this.noOfCHD;
		}
		
		public void setNoOfCHD(int noOfCHD){
			this.noOfCHD = noOfCHD;
		}
		
		public int getNoOfT2D(){
			return this.noOfT2D;
		}
		
		public void setNoOfT2D(int noOfT2D){
			this.noOfT2D = noOfT2D;
		}
		
		public int getNoOfInterventionsIntro(){
			return this.noOfInterventionsIntro;
		}
		
		public void setNoOfInterventionsIntro(int noOfInterventionsIntro){
			this.noOfInterventionsIntro = noOfInterventionsIntro;
		}
		
		public int getNoOfInterventionsUptake(){
			return this.noOfInterventionsUptake;
		}
		
		public void setNoOfInterventionsUptake(int noOfInterventionsUptake){
			this.noOfInterventionsUptake = noOfInterventionsUptake;
		}
		
		public String getNameOfInterventionsIntro(){
			return this.nameOfInterventionsIntro;
		}
		
		public void setNameOfInterventionsIntro(String introName){
			this.nameOfInterventionsIntro += introName;
		}
		
		public String getNameOfInterventionsUptake(){
			return this.nameOfInterventionsUptake;
		}

		public void setNameOfInterventionsUptake(String uptakeName){
			this.nameOfInterventionsUptake += uptakeName; 
		}

		public double getTotalQALYs(){
			return this.totalQALYS;
		}
		
		public void setTotalQALYs(double totalQALYS){
			this.totalQALYS = totalQALYS;
		}
		
		public double getTotalQALYsDiscounted(){
			return this.totalQALYsDiscounted;
		}
		
		public void setTotalQALYsDiscounted(double totalQALYsDiscounted){
			this.totalQALYsDiscounted = totalQALYsDiscounted;
		}
		
		public double getTotalCost(){
			return this.totalCost;
		}
		
		public void setTotalCost(double totalCost){
			this.totalCost = totalCost;
		}
		
		public double getTotalCostDiscounted(){
			return this.totalCostDiscounted;
		}
		
		public void setTotalCostDiscounted(double totalCostDiscounted){
			this.totalCostDiscounted = totalCostDiscounted;
		}
		
		public double getTotalEventCost(){
			return this.totalEventCost;
		}
		
		public void setTotalEventCost(double totalEventCost){
			this.totalEventCost = totalEventCost;
		}
		
		public double getTotalEventCostDiscounted(){
			return this.totalEventCostDiscounted;
		}
		
		public void setTotalEventCostDiscounted(double totalEventCostDiscounted){
			this.totalEventCostDiscounted = totalEventCostDiscounted;
		}
		
		public double getTotalInterventionCost(){
			return this.totalInterventionCost;
		}
		
		public void setTotalInterventionCost(double totalInterventionCost){
			this.totalInterventionCost = totalInterventionCost;
		}
		
		public double getTotalInterventionCostDiscounted(){
			return this.totalInterventionCostDiscounted;
		}
		
		public void setTotalInterventionCostDiscounted(double totalInterventionCostDiscounted){
			this.totalInterventionCostDiscounted = totalInterventionCostDiscounted;
		}
		
		public double getTotalInterventionCostHealth(){
			return this.totalInterventionCost_health;
		}
		
		public void setTotalInterventionCostHealth(double totalInterventionCost_health){
			this.totalInterventionCost_health = totalInterventionCost_health;
		}
		
		public double getTotalInterventionCostHealthDiscounted(){
			return this.totalInterventionCost_healthDiscounted;
		}
		
		public void setTotalInterventionCostHealthDiscounted(double totalInterventionCost_healthDiscounted){
			this.totalInterventionCost_healthDiscounted = totalInterventionCost_healthDiscounted;
		}
		
		public double getTotalInterventionCostSport(){
			return this.totalInterventionCost_sport;
		}
		
		public void setTotalInterventionCostSport(double totalInterventionCost_sport){
			this.totalInterventionCost_sport = totalInterventionCost_sport;
		}
		
		public double getTotalInterventionCostSportDiscounted(){
			return this.totalInterventionCost_sportDiscounted;
		}
		
		public void setTotalInterventionCostSportDiscounted(double totalInterventionCost_sportDiscounted){
			this.totalInterventionCost_sportDiscounted = totalInterventionCost_sportDiscounted;
		}
		
		public double getTotalInterventionCostEducation(){
			return this.totalInterventionCost_education;
		}
		
		public void setTotalInterventionCostEducation(double totalInterventionCost_education){
			this.totalInterventionCost_education = totalInterventionCost_education;
		}
		
		public double getTotalInterventionCostEducationDiscounted(){
			return this.totalInterventionCost_educationDiscounted;
		}
		
		public void setTotalInterventionCostEducationDiscounted(double totalInterventionCost_educationDiscounted){
			this.totalInterventionCost_educationDiscounted = totalInterventionCost_educationDiscounted;
		}
		public double getTotalInterventionCostTransport(){
			return this.totalInterventionCost_transport;
		}
		
		public void setTotalInterventionCostTransport(double totalInterventionCost_transport){
			this.totalInterventionCost_transport = totalInterventionCost_transport;
		}
		
		public double getTotalInterventionCostTransportDiscounted(){
			return this.totalInterventionCost_transportDiscounted;
		}
		
		public void setTotalInterventionCostTransportDiscounted(double totalInterventionCost_transportDiscounted){
			this.totalInterventionCost_transportDiscounted = totalInterventionCost_transportDiscounted;
		}
		public double getTotalInterventionCostLocalAuthorities(){
			return this.totalInterventionCost_localAuthorities;
		}
		
		public void setTotalInterventionCostLocalAuthorities(double totalInterventionCost_localAuthorities){
			this.totalInterventionCost_localAuthorities = totalInterventionCost_localAuthorities;
		}
		
		public double getTotalInterventionCostLocalAuthoritiesDiscounted(){
			return this.totalInterventionCost_localAuthoritiesDiscounted;
		}
		
		public void setTotalInterventionCostLocalAuthoritiesDiscounted(double totalInterventionCost_localAuthoritiesDiscounted){
			this.totalInterventionCost_localAuthoritiesDiscounted = totalInterventionCost_localAuthoritiesDiscounted;
		}
		public double getTotalInterventionCostOther(){
			return this.totalInterventionCost_other;
		}
		
		public void setTotalInterventionCostOther(double totalInterventionCost_other){
			this.totalInterventionCost_other = totalInterventionCost_other;
		}
		
		public double getTotalInterventionCostOtherDiscounted(){
			return this.totalInterventionCost_otherDiscounted;
		}
		
		public void setTotalInterventionCostOtherDiscounted(double totalInterventionCost_otherDiscounted){
			this.totalInterventionCost_otherDiscounted = totalInterventionCost_otherDiscounted;
		}
		
		public double getCurrentUtility(){
			return this.currentUtility;
		}
		public void setCurrentUtility(double currentUtility){
			this.currentUtility = currentUtility;
		}
		
		public double getBaselineUtility(){
			return this.baselineUtility;
		}
		public void setBaselineUtility(double baselineUtility){
			this.baselineUtility = baselineUtility;
		}
		
		public double getPAPreviousPeriod(){
			return this.paPreviousPeriod;
		}
		public void setPAPreviousPeriod(double paPreviousPeriod){
			this.paPreviousPeriod = paPreviousPeriod;
		}
		
		public double getDprsProbability(){
			return this.dprsProbability;
		}
		public void setDprsProbability(double dprsProbability){
			this.dprsProbability = dprsProbability;
		}
		
		public double getMSIProbability(){
			return this.msiProbability;
		}
		public void setMSIProbability(double msiProbability){
			this.msiProbability = msiProbability;
		}		
		
		/*
		public void clearEventHistory(){
			this.eventHistory.clear();
		}
		*/
		
		public String getCauseOfDeath(){
			return this.causeOfDeath;
		}
		
		public void setCauseOfDeath(String causeOfDeath){
			this.causeOfDeath = causeOfDeath;
		}

		public void clearCHDEventsList(){
			this.chdEventsList.clear();
		}
		
		public void clearStrokeEventsList(){
			this.strokeEventsList.clear();
		}
		
		public void clearT2DEventsList(){
			this.t2dEventsList.clear();
		}
		
		public void clearMSIEventsList(){
			this.msiEventsList.clear();
		}
		
		public void clearDepressionEventsList(){
			this.depressionEventsList.clear();
		}
		
		public void clearInterventionsIntroducedList(){
			this.interventionsIntroducedList.clear();
		}
		public void clearInterventionsUptakeList(){
			this.interventionsUptakeList.clear();
		}
		
		public ArrayList<OccuredEvent> getCHDEventsList(){
			return this.chdEventsList;
		}
		
		public ArrayList<OccuredEvent> getStrokeEventsList(){
			return this.strokeEventsList;
		}
		
		public ArrayList<OccuredEvent> getT2DEventsList(){
			return this.t2dEventsList;
		}

		public ArrayList<OccuredEvent> getMSIEventsList(){
			return this.msiEventsList;
		}

		public ArrayList<OccuredEvent> getDepressionEventsList(){
			return this.depressionEventsList;
		}

		public ArrayList<IntroducedIntervention> getIntroducedIntervention(){
			return this.interventionsIntroducedList;
		}
		
		public ArrayList<UptakeIntervention> getUptakeIntervention(){
			return this.interventionsUptakeList;
		}
		
		
}

