package pa_model;

public class IntroducedIntervention {
	
	private double startTime;
	
	private String introGender, interventionName;
	
	private int duration, effectStartTime;
	private double minIntroAge, maxIntroAge, minIntroPA, maxIntroPA, uptakeProbability, effectOnPAMean, effectOnPASD,
	healthFixedCost, healthIndividualCostMonth, sportFixedCost, sportIndividualCostMonth, educationFixedCost, educationIndividualCostMonth,
	transportFixedCost, transportIndividualCostMonth, localAuthoritiesFixedCost, localAuthoritiesIndividualCostMonth, otherFixedCost, otherIndividualCostMonth;
	
	private boolean introducedIntervention = false;
	
	public IntroducedIntervention(Record rec, Agent a){
		
		startTime = Util.getCurrentTime();
		introGender = a.getGender();
		interventionName = rec.getInterventionName(a.repReadData);
		duration = rec.getInterventionDurationInMonths(a.repReadData);
		effectStartTime = rec.getInterventionEffectStartTineInMonths(a.repReadData);
		minIntroAge = rec.getInterventionIntroAgeMin(a.repReadData);
		maxIntroAge = rec.getInterventionIntroAgeMax(a.repReadData);
		minIntroPA = rec.getInterventionIntroPAStatusMin(a.repReadData);
		maxIntroPA = rec.getInterventionIntroPAStatusMax(a.repReadData);
		uptakeProbability = rec.getInterventionUptakeProbability(a.repReadData);
		effectOnPAMean = rec.getInterventionEffectOnPAmean(a.repReadData);
		effectOnPASD = rec.getInterventionEffectOnPAsd(a.repReadData);
		healthFixedCost = rec.getInterventionHealthSectorFixedCost(a.repReadData);
		healthIndividualCostMonth = rec.getInterventionHealthSectorIndividualCostPerMonth(a.repReadData);
		sportFixedCost = rec.getInterventionSportSectorFixedCost(a.repReadData);
		sportIndividualCostMonth = rec.getInterventionSportSectorIndividualCostPerMonth(a.repReadData);
		educationFixedCost = rec.getInterventionEducationSectorFixedCost(a.repReadData);
		educationIndividualCostMonth = rec.getInterventionEducationSectorIndividualCostPerMonth(a.repReadData);
		transportFixedCost = rec.getInterventionTransportSectorFixedCost(a.repReadData);
		transportIndividualCostMonth = rec.getInterventionTransportSectorIndividualCostPerMonth(a.repReadData);
		localAuthoritiesFixedCost = rec.getInterventionLocalAuthoritiesFixedCost(a.repReadData);
		localAuthoritiesIndividualCostMonth = rec.getInterventionLocalAuthoritiesIndividualCostPerMonth(a.repReadData);
		otherFixedCost = rec.getInterventionOtherSectorFixedCost(a.repReadData);
		otherIndividualCostMonth = rec.getInterventionOtherSectorIndividualCostPerMonth(a.repReadData);
	}

		public boolean getIntroducedIntervention(){
			return this.introducedIntervention;
		}
	
		public void setIntroducedIntervention(boolean b){
			this.introducedIntervention = b;
		}
		
		public double getStartTime(){
			return this.startTime;
		}
		public String getIntroGender(){
			return this.introGender;
		}
		public String getInterventionName(){
			return this.interventionName;
		}
		public int getInterventionDuration(){
			return this.duration;
		}
		public int getEffectStartTimeMonths(){
			return this.effectStartTime;
		} 
		public double getMinIntroAge(){
			return this.minIntroAge;
		}
		public double getMaxIntroAge(){
			return this.maxIntroAge;
		}
		public double getMinIntroPA(){
			return this.minIntroPA;
		}
		public double getMaxIntroPA(){
			return this.maxIntroPA;
		}
		public double getUptakeProbability(){
			return this.uptakeProbability;
		}
		public double getEffectOnPAMean(){
			return this.effectOnPAMean;
		}
		public double getEffectOnPASD(){
			return this.effectOnPASD;
		}
		public double getHealthFixedCost(){
			return this.healthFixedCost;
		}
		public double getHealthIndividualCostMonth(){
			return this.healthIndividualCostMonth;
		}
		public double getSportFixedCost(){
			return this.sportFixedCost;
		}
		public double getSportIndividualCostMonth(){
			return this.sportIndividualCostMonth;
		}
		public double getEducationFixedCost(){
			return this.educationFixedCost;
		}
		public double getEducationIndividualCostMonth(){
			return this.educationIndividualCostMonth;
		}
		public double getTransportFixedCost(){
			return this.transportFixedCost;
		}
		public double getTransportIndividualCostMonth(){
			return this.transportIndividualCostMonth;
		}
		public double getLocalAuthoritiesFixedCost(){
			return this.localAuthoritiesFixedCost;
		}
		public double getLocalAuthoritiesIndividualCostMonth(){
			return this.localAuthoritiesIndividualCostMonth;
		}
		public double getOtherFixedCost(){
			return this.otherFixedCost;
		}
		public double getOtherIndividualCostMonth(){
			return this.otherIndividualCostMonth;
		}
			
}
